diff -r 873d6d76778e trytond/modules/calendar_todo/webdav.py
--- a/trytond/modules/calendar_todo/webdav.py	Wed Sep 19 22:19:45 2012 +0200
+++ b/trytond/modules/calendar_todo/webdav.py	Mon Sep 24 20:36:40 2012 +0200
@@ -3,36 +3,33 @@
 import vobject
 import urllib
 from pywebdav.lib.errors import DAV_NotFound, DAV_Forbidden
-from trytond.model import ModelView, ModelSQL
 from trytond.tools import reduce_ids
 from trytond.transaction import Transaction
 from trytond.cache import Cache
-from trytond.pool import Pool
+from trytond.pool import Pool, PoolMeta
 
+__all__ = ['Collection']
+__metaclass__ = PoolMeta
 
-class Collection(ModelSQL, ModelView):
 
-    _name = "webdav.collection"
+class Collection:
+    __name__ = "webdav.collection"
+    _todo_cache = Cache('webdav_collection.todo')
 
-    @Cache('webdav_collection.todo')
-    def todo(self, uri, calendar_id=False):
+    @classmethod
+    def todo(cls, uri, calendar_id=False):
         '''
         Return the todo id in the uri
-
-        :param uri: the uri
-        :param calendar_id: the calendar id
-        :return: todo id
-            or None if there is no todo
         '''
-        todo_obj = Pool().get('calendar.todo')
+        Todo = Pool().get('calendar.todo')
 
         if uri and uri.startswith('Calendars/'):
             calendar, todo_uri = (uri[10:].split('/', 1) + [None])[0:2]
             if not calendar_id:
-                calendar_id = self.calendar(uri)
+                calendar_id = cls.calendar(uri)
                 if not calendar_id:
                     return None
-            todo_ids = todo_obj.search([
+            todo_ids = Todo.search([
                 ('calendar', '=', calendar_id),
                 ('uuid', '=', todo_uri[:-4]),
                 ('parent', '=', None),
@@ -40,12 +37,10 @@
             if todo_ids:
                 return todo_ids[0]
 
-    def _caldav_filter_domain_todo(self, filter):
+    @classmethod
+    def _caldav_filter_domain_todo(cls, filter):
         '''
         Return a domain for caldav filter on todo
-
-        :param filter: the DOM Element of filter
-        :return: a list for domain
         '''
         res = []
         if not filter:
@@ -98,78 +93,81 @@
                         continue
                     if uri:
                         uri = urllib.unquote_plus(uri)
-                    todo_id = self.todo(uri)
+                    todo_id = cls.todo(uri)
                     if todo_id:
                         ids.append(todo_id)
             return [('id', 'in', ids)]
         return res
 
-    def get_childs(self, uri, filter=None, cache=None):
-        todo_obj = Pool().get('calendar.todo')
+    @classmethod
+    def get_childs(cls, uri, filter=None, cache=None):
+        Todo = Pool().get('calendar.todo')
 
-        res = super(Collection, self).get_childs(uri, filter=filter,
+        res = super(Collection, cls).get_childs(uri, filter=filter,
                 cache=cache)
 
         if uri and (uri not in ('Calendars', 'Calendars/')) and \
                 uri.startswith('Calendars/'):
-            calendar_id = self.calendar(uri)
+            calendar_id = cls.calendar(uri)
             if  calendar_id and not (uri[10:].split('/', 1) + [None])[1]:
-                domain = self._caldav_filter_domain_todo(filter)
-                todo_ids = todo_obj.search([
+                domain = cls._caldav_filter_domain_todo(filter)
+                todos = Todo.search([
                     ('calendar', '=', calendar_id),
                     domain,
                     ])
-                todos = todo_obj.browse(todo_ids)
                 if cache is not None:
                     cache.setdefault('_calendar', {})
-                    cache['_calendar'].setdefault(todo_obj._name, {})
-                    for todo_id in todo_ids:
-                        cache['_calendar'][todo_obj._name][todo_id] = {}
+                    cache['_calendar'].setdefault(Todo.__name__, {})
+                    for todo in todos:
+                        cache['_calendar'][Todo.__name__][todo.id] = {}
                 return res + [x.uuid + '.ics' for x in todos]
 
         return res
 
-    def get_resourcetype(self, uri, cache=None):
+    @classmethod
+    def get_resourcetype(cls, uri, cache=None):
         from DAV.constants import COLLECTION, OBJECT
         if uri in ('Calendars', 'Calendars/'):
             return COLLECTION
-        calendar_id = self.calendar(uri)
+        calendar_id = cls.calendar(uri)
         if calendar_id:
             if not (uri[10:].split('/', 1) + [None])[1]:
                 return COLLECTION
-            if self.todo(uri, calendar_id=calendar_id):
+            if cls.todo(uri, calendar_id=calendar_id):
                 return OBJECT
-        elif self.calendar(uri, ics=True):
+        elif cls.calendar(uri, ics=True):
             return OBJECT
-        return super(Collection, self).get_resourcetype(uri, cache=cache)
+        return super(Collection, cls).get_resourcetype(uri, cache=cache)
 
-    def get_contenttype(self, uri, cache=None):
-        if self.todo(uri) \
-                or self.calendar(uri, ics=True):
+    @classmethod
+    def get_contenttype(cls, uri, cache=None):
+        if (cls.todo(uri)
+                or cls.calendar(uri, ics=True)):
             return 'text/calendar'
-        return super(Collection, self).get_contenttype(uri, cache=cache)
+        return super(Collection, cls).get_contenttype(uri, cache=cache)
 
-    def get_creationdate(self, uri, cache=None):
-        todo_obj = Pool().get('calendar.todo')
+    @classmethod
+    def get_creationdate(cls, uri, cache=None):
+        Todo = Pool().get('calendar.todo')
 
         cursor = Transaction().cursor
 
-        calendar_id = self.calendar(uri)
+        calendar_id = cls.calendar(uri)
         if not calendar_id:
-            calendar_id = self.calendar(uri, ics=True)
+            calendar_id = cls.calendar(uri, ics=True)
         if calendar_id and (uri[10:].split('/', 1) + [None])[1]:
 
-            todo_id = self.todo(uri, calendar_id=calendar_id)
+            todo_id = cls.todo(uri, calendar_id=calendar_id)
             if todo_id:
                 if cache is not None:
                     cache.setdefault('_calendar', {})
-                    cache['_calendar'].setdefault(todo_obj._name, {})
-                    ids = cache['_calendar'][todo_obj._name].keys()
+                    cache['_calendar'].setdefault(Todo.__name__, {})
+                    ids = cache['_calendar'][Todo.__name__].keys()
                     if todo_id not in ids:
                         ids.append(todo_id)
                     elif 'creationdate' in cache['_calendar'][
-                            todo_obj._name][todo_id]:
-                        return cache['_calendar'][todo_obj._name][
+                            Todo.__name__][todo_id]:
+                        return cache['_calendar'][Todo.__name__][
                             todo_id]['creationdate']
                 else:
                     ids = [todo_id]
@@ -179,39 +177,40 @@
                     red_sql, red_ids = reduce_ids('id', sub_ids)
                     cursor.execute('SELECT id, ' \
                             'EXTRACT(epoch FROM create_date) ' \
-                        'FROM "' + todo_obj._table + '" ' \
+                        'FROM "' + Todo.__table__ + '" ' \
                         'WHERE ' + red_sql, red_ids)
                     for todo_id2, date in cursor.fetchall():
                         if todo_id2 == todo_id:
                             res = date
                         if cache is not None:
-                            cache['_calendar'][todo_obj._name]\
+                            cache['_calendar'][Todo.__name__]\
                                     .setdefault(todo_id2, {})
-                            cache['_calendar'][todo_obj._name][
+                            cache['_calendar'][Todo.__name__][
                                 todo_id2]['creationdate'] = date
                 if res is not None:
                     return res
 
-        return super(Collection, self).get_creationdate(uri, cache=cache)
+        return super(Collection, cls).get_creationdate(uri, cache=cache)
 
-    def get_lastmodified(self, uri, cache=None):
-        todo_obj = Pool().get('calendar.todo')
+    @classmethod
+    def get_lastmodified(cls, uri, cache=None):
+        Todo = Pool().get('calendar.todo')
 
         cursor = Transaction().cursor
 
-        calendar_id = self.calendar(uri)
+        calendar_id = cls.calendar(uri)
         if calendar_id and (uri[10:].split('/', 1) + [None])[1]:
-            todo_id = self.todo(uri, calendar_id=calendar_id)
+            todo_id = cls.todo(uri, calendar_id=calendar_id)
             if todo_id:
                 if cache is not None:
                     cache.setdefault('_calendar', {})
-                    cache['_calendar'].setdefault(todo_obj._name, {})
-                    ids = cache['_calendar'][todo_obj._name].keys()
+                    cache['_calendar'].setdefault(Todo.__name__, {})
+                    ids = cache['_calendar'][Todo.__name__].keys()
                     if todo_id not in ids:
                         ids.append(todo_id)
                     elif 'lastmodified' in cache['_calendar'][
-                            todo_obj._name][todo_id]:
-                        return cache['_calendar'][todo_obj._name][
+                            Todo.__name__][todo_id]:
+                        return cache['_calendar'][Todo.__name__][
                             todo_id]['lastmodified']
                 else:
                     ids = [todo_id]
@@ -224,7 +223,7 @@
                     cursor.execute('SELECT COALESCE(parent, id), ' \
                                 'MAX(EXTRACT(epoch FROM ' \
                                 'COALESCE(write_date, create_date))) ' \
-                            'FROM "' + todo_obj._table + '" ' \
+                            'FROM "' + Todo.__table__ + '" ' \
                             'WHERE ' + red_id_sql + ' ' \
                                 'OR ' + red_parent_sql + ' ' \
                             'GROUP BY parent, id', red_id_ids + red_parent_ids)
@@ -232,83 +231,85 @@
                         if todo_id2 == todo_id:
                             res = date
                         if cache is not None:
-                            cache['_calendar'][todo_obj._name]\
+                            cache['_calendar'][Todo.__name__]\
                                     .setdefault(todo_id2, {})
-                            cache['_calendar'][todo_obj._name][
+                            cache['_calendar'][Todo.__name__][
                                 todo_id2]['lastmodified'] = date
                 if res is not None:
                     return res
 
-        return super(Collection, self).get_lastmodified(uri, cache=cache)
+        return super(Collection, cls).get_lastmodified(uri, cache=cache)
 
-    def get_data(self, uri, cache=None):
-        todo_obj = Pool().get('calendar.todo')
+    @classmethod
+    def get_data(cls, uri, cache=None):
+        Todo = Pool().get('calendar.todo')
 
-        calendar_id = self.calendar(uri)
+        calendar_id = cls.calendar(uri)
         if calendar_id:
             if not (uri[10:].split('/', 1) + [None])[1]:
                 raise DAV_NotFound
-            todo_id = self.todo(uri, calendar_id=calendar_id)
+            todo_id = cls.todo(uri, calendar_id=calendar_id)
             if not todo_id:
-                return super(Collection, self).get_data(uri, cache=cache)
-            ical = todo_obj.todo2ical(todo_id)
+                return super(Collection, cls).get_data(uri, cache=cache)
+            ical = Todo(todo_id).todo2ical()
             return ical.serialize()
 
-        return super(Collection, self).get_data(uri, cache=cache)
+        return super(Collection, cls).get_data(uri, cache=cache)
 
-    def put(self, uri, data, content_type, cache=None):
-        todo_obj = Pool().get('calendar.todo')
-        calendar_obj = Pool().get('calendar.calendar')
+    @classmethod
+    def put(cls, uri, data, content_type, cache=None):
+        pool = Pool()
+        Todo = pool.get('calendar.todo')
+        Calendar = pool.get('calendar.calendar')
 
-        calendar_id = self.calendar(uri)
+        calendar_id = cls.calendar(uri)
         if calendar_id:
             if not (uri[10:].split('/', 1) + [None])[1]:
                 raise DAV_Forbidden
-            todo_id = self.todo(uri, calendar_id=calendar_id)
+            todo_id = cls.todo(uri, calendar_id=calendar_id)
             ical = vobject.readOne(data)
             if not hasattr(ical, 'vtodo'):
-                return super(Collection, self).put(uri, data, content_type)
+                return super(Collection, cls).put(uri, data, content_type)
 
             if not todo_id:
 
-                values = todo_obj.ical2values(None, ical, calendar_id)
-                todo_id = todo_obj.create(values)
-                todo = todo_obj.browse(todo_id)
-                calendar = calendar_obj.browse(calendar_id)
+                values = Todo.ical2values(None, ical, calendar_id)
+                todo = Todo.create(values)
+                calendar = Calendar(calendar_id)
                 return Transaction().cursor.database_name + '/Calendars/' + \
                         calendar.name + '/' + todo.uuid + '.ics'
             else:
-                values = todo_obj.ical2values(todo_id, ical, calendar_id)
-                todo_obj.write(todo_id, values)
+                values = Todo.ical2values(todo_id, ical, calendar_id)
+                Todo.write([Todo(todo_id)], values)
                 return
 
-        return super(Collection, self).put(uri, data, content_type)
+        return super(Collection, cls).put(uri, data, content_type)
 
-    def rm(self, uri, cache=None):
-        todo_obj = Pool().get('calendar.todo')
+    @classmethod
+    def rm(cls, uri, cache=None):
+        Todo = Pool().get('calendar.todo')
 
-        calendar_id = self.calendar(uri)
+        calendar_id = cls.calendar(uri)
         if calendar_id:
             if not (uri[10:].split('/', 1) + [None])[1]:
                 raise DAV_Forbidden
-            todo_id = self.todo(uri, calendar_id=calendar_id)
+            todo_id = cls.todo(uri, calendar_id=calendar_id)
             if todo_id:
                 try:
-                    todo_obj.delete(todo_id)
+                    Todo.delete([Todo(todo_id)])
                 except Exception:
                     raise DAV_Forbidden
                 return 200
-        return super(Collection, self).rm(uri, cache=cache)
+        return super(Collection, cls).rm(uri, cache=cache)
 
-    def exists(self, uri, cache=None):
+    @classmethod
+    def exists(cls, uri, cache=None):
         if uri in ('Calendars', 'Calendars/'):
             return 1
-        calendar_id = self.calendar(uri)
+        calendar_id = cls.calendar(uri)
         if calendar_id:
             if not (uri[10:].split('/', 1) + [None])[1]:
                 return 1
-            if self.todo(uri, calendar_id=calendar_id):
+            if cls.todo(uri, calendar_id=calendar_id):
                 return 1
-        return super(Collection, self).exists(uri, cache=cache)
-
-Collection()
+        return super(Collection, cls).exists(uri, cache=cache)
diff -r e34b5d9c283b trytond/modules/carrier/__init__.py
--- a/trytond/modules/carrier/__init__.py	Fri Jun 08 19:33:51 2012 +0200
+++ b/trytond/modules/carrier/__init__.py	Mon Sep 24 20:36:40 2012 +0200
@@ -1,4 +1,11 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 
+from trytond.pool import Pool
 from .carrier import *
+
+
+def register():
+    Pool.register(
+        Carrier,
+        module='carrier', type_='model')
diff -r e34b5d9c283b trytond/modules/carrier/carrier.py
--- a/trytond/modules/carrier/carrier.py	Fri Jun 08 19:33:51 2012 +0200
+++ b/trytond/modules/carrier/carrier.py	Mon Sep 24 20:36:40 2012 +0200
@@ -4,12 +4,13 @@
 from trytond.transaction import Transaction
 from trytond.pool import Pool
 
+__all__ = ['Carrier']
+
 
 class Carrier(ModelSQL, ModelView):
     'Carrier'
-    _name = 'carrier'
+    __name__ = 'carrier'
     _inherits = {'party.party': 'party'}
-
     party = fields.Many2One('party.party', 'Party', required=True,
             ondelete='CASCADE')
     carrier_product = fields.Many2One('product.product', 'Carrier Product',
@@ -21,52 +22,41 @@
         ], 'Carrier Cost Method', required=True,
         help='Method to compute carrier cost')
 
-    def default_carrier_cost_method(self):
+    @staticmethod
+    def default_carrier_cost_method():
         return 'product'
 
-    def get_rec_name(self, ids, name):
-        if not ids:
-            return {}
-        names = {}
-        for carrier in self.browse(ids):
-            names[carrier.id] = '%s - %s' % (carrier.party.rec_name,
-                carrier.carrier_product.rec_name)
-        return names
+    def get_rec_name(self, name):
+        return '%s - %s' % (self.party.rec_name, self.carrier_product.rec_name)
 
-    def copy(self, ids, default=None):
-        party_obj = Pool().get('party.party')
+    @classmethod
+    def copy(self, carriers, default=None):
+        Party = Pool().get('party.party')
 
-        int_id = False
-        if isinstance(ids, (int, long)):
-            int_id = True
-            ids = [ids]
         if default is None:
             default = {}
         default = default.copy()
-        new_ids = []
-        for carrier in self.browse(ids):
-            default['party'] = party_obj.copy(carrier.party.id)
-            new_id = super(Carrier, self).copy(carrier.id, default=default)
-            new_ids.append(new_id)
-        if int_id:
-            return new_ids[0]
-        return new_ids
+        new_carriers = []
+        for carrier in carriers:
+            party, = Party.copy([carrier.party])
+            default['party'] = party.id
+            new_carriers.extend(super(Carrier, self).copy([carrier],
+                    default=default))
+        return new_carriers
 
-    def get_sale_price(self, carrier):
+    def get_sale_price(self):
         'Compute carrier sale price with currency'
-        user_obj = Pool().get('res.user')
-        if carrier.carrier_cost_method == 'product':
-            user = user_obj.browse(Transaction().user
+        User = Pool().get('res.user')
+        if self.carrier_cost_method == 'product':
+            user = User(Transaction().user
                 or Transaction().context.get('user'))
-            return carrier.carrier_product.list_price, user.company.currency.id
+            return self.carrier_product.list_price, user.company.currency.id
         return 0, None
 
-    def get_purchase_price(self, carrier):
+    def get_purchase_price(self):
         'Compute carrier purchase price with currency'
-        user_obj = Pool().get('res.user')
-        if carrier.carrier_cost_method == 'product':
-            user = user_obj.browse(Transaction().user)
-            return carrier.carrier_product.cost_price, user.company.currency.id
+        User = Pool().get('res.user')
+        if self.carrier_cost_method == 'product':
+            user = User(Transaction().user)
+            return self.carrier_product.cost_price, user.company.currency.id
         return 0, None
-
-Carrier()
diff -r 1f2c537229ab trytond/modules/carrier_percentage/__init__.py
--- a/trytond/modules/carrier_percentage/__init__.py	Tue Sep 11 15:29:50 2012 +0200
+++ b/trytond/modules/carrier_percentage/__init__.py	Mon Sep 24 20:36:40 2012 +0200
@@ -1,6 +1,16 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 
+from trytond.pool import Pool
 from carrier import *
 from stock import *
 from sale import *
+
+
+def register():
+    Pool.register(
+        Carrier,
+        ShipmentIn,
+        ShipmentOut,
+        Sale,
+        module='carrier_percentage', type_='model')
diff -r 1f2c537229ab trytond/modules/carrier_percentage/carrier.py
--- a/trytond/modules/carrier_percentage/carrier.py	Tue Sep 11 15:29:50 2012 +0200
+++ b/trytond/modules/carrier_percentage/carrier.py	Mon Sep 24 20:36:40 2012 +0200
@@ -1,56 +1,52 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
-import copy
 from decimal import Decimal
-from trytond.model import Model, fields
+from trytond.model import fields
 from trytond.transaction import Transaction
-from trytond.pool import Pool
+from trytond.pool import Pool, PoolMeta
 from trytond.pyson import Eval
 
+__all__ = ['Carrier']
+__metaclass__ = PoolMeta
 
-class Carrier(Model):
-    _name = 'carrier'
 
+class Carrier:
+    __name__ = 'carrier'
     percentage = fields.Numeric('Percentage', digits=(16, 8),
         states={
             'invisible': Eval('carrier_cost_method') != 'percentage',
             },
         depends=['carrier_cost_method'])
 
-    def __init__(self):
-        super(Carrier, self).__init__()
-        self.carrier_cost_method = copy.copy(self.carrier_cost_method)
-        self.carrier_cost_method.selection = \
-            self.carrier_cost_method.selection[:]
+    @classmethod
+    def __setup__(cls):
+        super(Carrier, cls).__setup__()
         selection = ('percentage', 'Percentage')
-        if selection not in self.carrier_cost_method.selection:
-            self.carrier_cost_method.selection.append(selection)
-        self._reset_columns()
+        if selection not in cls.carrier_cost_method.selection:
+            cls.carrier_cost_method.selection.append(selection)
 
-    def compute_percentage(self, carrier, amount, currency_id):
+    def compute_percentage(self, amount, currency_id):
         "Compute price based on a percentage of amount"
-        currency_obj = Pool().get('currency.currency')
+        Currency = Pool().get('currency.currency')
 
-        price = amount * carrier.percentage / Decimal(100)
+        price = amount * self.percentage / Decimal(100)
         if not currency_id:
             return price, currency_id
-        currency = currency_obj.browse(currency_id)
-        return currency_obj.round(currency, price), currency_id
+        currency = Currency(currency_id)
+        return currency.round(price), currency_id
 
-    def get_sale_price(self, carrier):
-        price, currency_id = super(Carrier, self).get_sale_price(carrier)
-        if carrier.carrier_cost_method == 'percentage':
+    def get_sale_price(self):
+        price, currency_id = super(Carrier, self).get_sale_price()
+        if self.carrier_cost_method == 'percentage':
             amount = Transaction().context.get('amount', Decimal(0))
             currency_id = Transaction().context.get('currency', currency_id)
-            return self.compute_percentage(carrier, amount, currency_id)
+            return self.compute_percentage(amount, currency_id)
         return price, currency_id
 
-    def get_purchase_price(self, carrier):
-        price, currency_id = super(Carrier, self).get_purchase_price(carrier)
-        if carrier.carrier_cost_method == 'percentage':
+    def get_purchase_price(self):
+        price, currency_id = super(Carrier, self).get_purchase_price()
+        if self.carrier_cost_method == 'percentage':
             amount = Transaction().context.get('amount', Decimal(0))
             currency_id = Transaction().context.get('currency', currency_id)
-            return self.compute_percentage(carrier, amount, currency_id)
+            return self.compute_percentage(amount, currency_id)
         return price, currency_id
-
-Carrier()
diff -r 1f2c537229ab trytond/modules/carrier_percentage/sale.py
--- a/trytond/modules/carrier_percentage/sale.py	Tue Sep 11 15:29:50 2012 +0200
+++ b/trytond/modules/carrier_percentage/sale.py	Mon Sep 24 20:36:40 2012 +0200
@@ -2,33 +2,28 @@
 #this repository contains the full copyright notices and license terms.
 from decimal import Decimal
 
-from trytond.model import Model
-from trytond.pool import Pool
+from trytond.pool import PoolMeta
 
+__all__ = ['Sale']
+__metaclass__ = PoolMeta
 
-class Sale(Model):
-    _name = 'sale.sale'
 
-    def _get_carrier_context(self, values):
-        pool = Pool()
-        carrier_obj = pool.get('carrier')
+class Sale:
+    __name__ = 'sale.sale'
 
-        context = super(Sale, self)._get_carrier_context(values)
+    def _get_carrier_context(self):
+        context = super(Sale, self)._get_carrier_context()
 
-        carrier = carrier_obj.browse(values['carrier'])
-        if carrier.carrier_cost_method != 'percentage':
+        if self.carrier.carrier_cost_method != 'percentage':
             return context
-        if not values.get('currency'):
+        if not self.currency:
             return context
         context = context.copy()
         amount = 0
-        for line in values.get('lines') or []:
-            if (line.get('unit_price') and line.get('quantity')
-                    and not line.get('shipment_cost')):
-                amount += (line['unit_price']
-                    * Decimal(str(line['quantity'] or 0)))
+        for line in self.lines or []:
+            if line.unit_price and line.quantity and not line.shipment_cost:
+                amount += (line.unit_price
+                    * Decimal(str(line.quantity or 0)))
         context['amount'] = amount
-        context['currency'] = values['currency']
+        context['currency'] = self.currency.id
         return context
-
-Sale()
diff -r 1f2c537229ab trytond/modules/carrier_percentage/stock.py
--- a/trytond/modules/carrier_percentage/stock.py	Tue Sep 11 15:29:50 2012 +0200
+++ b/trytond/modules/carrier_percentage/stock.py	Mon Sep 24 20:36:40 2012 +0200
@@ -1,105 +1,64 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 from decimal import Decimal
-from itertools import izip
 
-from trytond.model import Model
-from trytond.pool import Pool
+from trytond.pool import Pool, PoolMeta
 from trytond.transaction import Transaction
 
+__all__ = ['ShipmentIn', 'ShipmentOut']
+__metaclass__ = PoolMeta
+
 
 def _percentage_amount(lines, company):
     pool = Pool()
-    move_obj = pool.get('stock.move')
-    currency_obj = pool.get('currency.currency')
+    Move = pool.get('stock.move')
+    Currency = pool.get('currency.currency')
 
     amount = 0
     for line in lines or []:
-        if line['id'] >= 0:
-            move = move_obj.browse(line['id'])
-        else:
-            move = None
-        if 'unit_price' in line:
-            unit_price = line['unit_price']
-        elif move:
-            unit_price = move.unit_price
-        elif hasattr(move_obj, 'default_unit_price'):
-            unit_price = move_obj.default_unit_price()
-        else:
-            unit_price = Decimal('0')
-        if 'currency' in line:
-            currency_id = line['currency']
-        elif move:
-            currency_id = move.currency.id
-        elif hasattr(move_obj, 'default_currency'):
-            currency_id = move_obj.default_currency()
-        else:
-            currency_id = None
-        if currency_id:
-            unit_price = currency_obj.compute(currency_id, unit_price,
-                company.currency.id, round=False)
-        amount += unit_price * Decimal(str(line['quantity'] or 0))
+        unit_price = getattr(line, 'unit_price',
+            Move.default_unit_price() if hasattr(Move, 'default_unit_price')
+            else Decimal(0))
+        currency = getattr(line, 'currency',
+            Move.default_currency() if hasattr(Move, 'default_currency')
+            else None)
+        if currency:
+            unit_price = Currency.compute(currency, unit_price,
+                company.currency, round=False)
+        amount += unit_price * Decimal(str(line.quantity or 0))
     return amount
 
 
-class ShipmentIn(Model):
-    _name = 'stock.shipment.in'
+class ShipmentIn:
+    __name__ = 'stock.shipment.in'
 
-    def _get_carrier_context(self, values):
-        pool = Pool()
-        carrier_obj = pool.get('carrier')
-        company_obj = pool.get('company.company')
-        context = super(ShipmentIn, self)._get_carrier_context(values)
-        if not values.get('carrier'):
+    def _get_carrier_context(self):
+        Company = Pool().get('company.company')
+        context = super(ShipmentIn, self)._get_carrier_context()
+        if not self.carrier:
             return context
         context = context.copy()
-        carrier = carrier_obj.browse(values['carrier'])
-        if carrier.carrier_cost_method != 'percentage':
+        if self.carrier.carrier_cost_method != 'percentage':
             return context
-        company = company_obj.browse(Transaction().context['company'])
-        context['amount'] = _percentage_amount(values['incoming_moves'],
-            company)
+        company = Company(Transaction().context['company'])
+        context['amount'] = _percentage_amount(self.incoming_moves, company)
         context['currency'] = company.currency.id
         return context
 
-ShipmentIn()
 
+class ShipmentOut:
+    __name__ = 'stock.shipment.out'
 
-class ShipmentOut(Model):
-    _name = 'stock.shipment.out'
+    def _get_carrier_context(self):
+        Company = Pool().get('company.company')
 
-    def _get_carrier_context(self, values):
-        pool = Pool()
-        carrier_obj = pool.get('carrier')
-        company_obj = pool.get('company.company')
-
-        context = super(ShipmentOut, self)._get_carrier_context(values)
-        if not values.get('carrier'):
+        context = super(ShipmentOut, self)._get_carrier_context()
+        if not self.carrier:
             return context
         context = context.copy()
-        carrier = carrier_obj.browse(values['carrier'])
-        if carrier.carrier_cost_method != 'percentage':
+        if self.carrier.carrier_cost_method != 'percentage':
             return context
-        company = company_obj.browse(Transaction().context['company'])
-        context['amount'] = _percentage_amount(values['inventory_moves'],
-            company)
+        company = Company(Transaction().context['company'])
+        context['amount'] = _percentage_amount(self.inventory_moves, company)
         context['currency'] = company.currency.id
         return context
-
-    def get_carrier_context(self, shipment, values=None):
-        if values is None:
-            values = {}
-        values = values.copy()
-        inventory_moves = [{
-                'id': m.id,
-                'unit_price': m.unit_price,
-                'currency': m.currency.id,
-                'quantity': m.quantity,
-                } for m in shipment.inventory_moves]
-        values.setdefault('inventory_moves', inventory_moves)
-        for new, old in izip(inventory_moves, values['inventory_moves']):
-            old.update(new)
-        return super(ShipmentOut, self).get_carrier_context(shipment,
-            values=values)
-
-ShipmentOut()
